/*
 * Created on Oct 28, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package insa.imagemailerlocal;

import insa.mailclient.ifc.*;
import insa.webcam.ifc.JMStudioIfc;

import java.awt.image.BufferedImage;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

/**
 * @author dan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ImageMailerLocal implements Runnable {

  private BundleContext context;
  private Properties props = new Properties();
  private boolean continu;

  public ImageMailerLocal(BundleContext bc) {
    super();
    this.context = bc;
    String classPath = System.getProperty("user.dir");
    try {
      String propsFile = classPath + File.separator + "lib" + File.separator + "bundle.properties";
      props.load(new FileInputStream(propsFile));
    }
    catch (Exception e1) {
      e1.printStackTrace();
    }
    continu = true;
  }

  private int[][] getImage(BundleContext context) {
    try {
			System.out.println("Get snapshot");
      ServiceReference sr = context.getServiceReference(JMStudioIfc.class.getName());
      JMStudioIfc jmstudio = (JMStudioIfc) context.getService(sr);
      return jmstudio.getSnapShot();
    }
    catch (RuntimeException e) {
      System.out.println("Webcam is not working");
    }
    return null;
  }

  private void sendImage(BundleContext context, String filename) {
    try {
			System.out.println("Send image : "+ filename);
      ServiceReference sr = context.getServiceReference(SendMailIfc.class.getName());
      SendMailIfc sendMail = (SendMailIfc) context.getService(sr);
      sendMail.send(
        props.getProperty("insa.mail.smtp"),
        props.getProperty("insa.mail.receiver"),
        props.getProperty("insa.mail.sender"),
        "mail with attachement",
        "test",
        filename);
    }
    catch (RuntimeException e) {
      System.out.println("Mail service is not working");
      e.printStackTrace();
    }
  }

  private void saveImage(BufferedImage bimg, String filename) {
    try {
			System.out.println("Save image : "+ filename);
      BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(filename));
      JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
      JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bimg);
      int quality = 100;
      quality = Math.max(0, Math.min(quality, 100));
      param.setQuality((float) quality / 100.0f, false);
      encoder.setJPEGEncodeParam(param);
      encoder.encode(bimg);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void run() {
		int counter = 0;
    while (continu) {
			counter++;
      System.out.println("Trying to send mail n°: "+counter);
      int[][] imgRGB = getImage(context);
      BufferedImage bimg;
      try {
        bimg = new BufferedImage(imgRGB.length, imgRGB[0].length, BufferedImage.TYPE_INT_RGB);
        for (int i = 0; i < imgRGB.length; i++)
          for (int j = 0; j < imgRGB[0].length; j++)
            bimg.setRGB(i, j, imgRGB[i][j]);
        if (bimg != null) {
          String filename = props.getProperty("insa.mail.tmpfile");
          saveImage(bimg, filename);
          sendImage(context, filename);
        }
      }
      catch (Exception e) {
        e.printStackTrace();
      }
      try {
        Thread.sleep(10000);
      }
      catch (InterruptedException e) {
        e.printStackTrace();
      }
    }
  }

  public void setContinu(boolean b) {
    continu = b;
  }
}
