/*
 * Created on Oct 28, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package insa.mailclient.service;

import insa.mailclient.ifc.SendMailIfc;

import java.io.File;
import java.util.Date;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

/**
 * @author dan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SendMail implements BundleActivator, SendMailIfc {
  String version = "1.01";

  public void start(BundleContext context) throws Exception {
    System.out.println("Oscar mail client service started : " + version);
		Properties props = new Properties();
		props.put("location", "localhost");
    context.registerService(SendMailIfc.class.getName(), this, props);
  }

  public void stop(BundleContext context) throws Exception {
    System.out.println("Oscar mail client service stopped : " + version);

  }

  public void send(String smtpServer, String to, String from, String subject, String body, String filename) {
    // create some properties and get the default Session
    Properties props = System.getProperties();
    props.put("mail.smtp.host", smtpServer);
    Session session = Session.getInstance(props, null);
    Message msg = getAttachementMessage(session, from, to, subject, body, filename);
    if (msg != null)
      try {
        Transport.send(msg);
      }
      catch (Exception e) {
        e.printStackTrace();
      }
  }

  private MimeMessage getAttachementMessage(
    Session session,
    String from,
    String to,
    String subject,
    String body,
    String filename) {
    MimeMessage msg = null;
    // create a message
    try {
      msg = new MimeMessage(session);
      msg.setFrom(new InternetAddress(from));
      InternetAddress[] address = { new InternetAddress(to)};
      msg.setRecipients(Message.RecipientType.TO, address);
      msg.setSubject(subject);
			msg.setText(body);
      // create and fill the first message part
      if (filename != null) {
        File f = new File(filename);
        if (f.exists()) {
          MimeBodyPart mbp1 = new MimeBodyPart();
          mbp1.setText(body);
          // create the second message part
          MimeBodyPart mbp2 = new MimeBodyPart();
          // attach the file to the message
          FileDataSource fds = new FileDataSource(filename);
          mbp2.setDataHandler(new DataHandler(fds));
          mbp2.setFileName(fds.getName());
          // create the Multipart and add its parts to it
          Multipart mp = new MimeMultipart();
          mp.addBodyPart(mbp1);
          mp.addBodyPart(mbp2);
          // add the Multipart to the message
          msg.setContent(mp);
        }
      }
      msg.setSentDate(new Date());
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return msg;
  }
}
